unit MDIMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ComCtrls, ObjCPal, StdCtrls, ExtCtrls, Menus, ObjPkg,
  ObjIntf, ObjStart, ObjLib, DCLIntf, DsgnIntf, ObjInsp, ObjEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    CompPal: TComponentPalette;
    Panel3: TPanel;
    btnNew: TSpeedButton;
    btnOpenReport: TSpeedButton;
    btnSaveReport: TSpeedButton;
    AdvSpeedButton1: TSpeedButton;
    AdvSpeedButton2: TSpeedButton;
    btnRun: TSpeedButton;
    btnEdit: TSpeedButton;
    PaletteMenu: TPopupMenu;
    ShowPaletteHints: TMenuItem;
    Hide2: TMenuItem;
    PaletteHelpItem: TMenuItem;
    N9: TMenuItem;
    Configure2: TMenuItem;
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    FileNewFormItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileClosedFilesItem: TMenuItem;
    N3: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FileSaveAllItem: TMenuItem;
    N4: TMenuItem;
    FileCloseItem: TMenuItem;
    FileCloseAllItem: TMenuItem;
    N2: TMenuItem;
    FileExitItem: TMenuItem;
    EditMenu: TMenuItem;
    EditUndoItem: TMenuItem;
    EditRedoItem: TMenuItem;
    N15: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    EditDeleteItem: TMenuItem;
    EditSelectAll: TMenuItem;
    N14: TMenuItem;
    EditAlignGridItem: TMenuItem;
    EditFrontItem: TMenuItem;
    EditBackItem: TMenuItem;
    EditAlignItem: TMenuItem;
    EditSizeItem: TMenuItem;
    EditScaleItem: TMenuItem;
    EditTabOrderItem: TMenuItem;
    CreationOrderItem: TMenuItem;
    ViewsMenu: TMenuItem;
    ViewObjectInspector: TMenuItem;
    ViewBrowserItem: TMenuItem;
    N1: TMenuItem;
    ViewSpeedBarItem: TMenuItem;
    ViewPaletteItem: TMenuItem;
    ViewSwapSourceFormItem: TMenuItem;
    ToolsMenu: TMenuItem;
    ToolsOptionsItem: TMenuItem;
    ToolsToolsItem: TMenuItem;
    HelpMenu: TMenuItem;
    HelpContentsItem: TMenuItem;
    HelpWhatsNew: TMenuItem;
    N13: TMenuItem;
    HelpAboutItem: TMenuItem;
    procedure btnNewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnRunClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses MDIChild, DemoUtils;

procedure TForm1.btnNewClick(Sender: TObject);
begin
  TForm2.Create(Self);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadPackageEx(Format('%sDCLSTD%d0.%s', [GetRootDir, VersionNo, PackageExt]));
  FInspector.Show;
  CompPal.RefreshTabs;
end;

procedure TForm1.btnRunClick(Sender: TObject);
var
  AForm: TForm;
  AStream: TMemoryStream;
  I: Integer;
begin
  AForm := ActiveMDIChild;
  if (AForm <> nil) and (AForm is TForm2) then
  begin
    TForm2(AForm).FEditor.EditControl(nil);
    AStream := TMemoryStream.Create;
    AStream.WriteComponentRes(AForm.ClassName, AForm);
    for I := AForm.ComponentCount-1 downto 0 do
      AForm.Components[I].Free;
    AStream.Position := 0;
    AStream.ReadComponentRes(AForm);
    AStream.Free;
  end;
end;

procedure TForm1.btnEditClick(Sender: TObject);
var
  AForm: TForm;
begin
  AForm := ActiveMDIChild;
  if (AForm <> nil) and (AForm is TForm2) then
    TForm2(AForm).FEditor.EditControl(AForm);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FInspector.Clear;
  UnLoadPackages;
end;

initialization
begin
  {Init IDE envirment for runtime design}
  ObjInitialize(TObjectInspector, TObjectEditor, nil, nil, nil);
end;

end.
